﻿Imports System.IO

Public Class Form1
    Public Aufgaben As New List(Of Aufgabe)
    Public Taetigkeiten As New List(Of Taetigkeit)
    Public xbutton As New List(Of tbutton)

    Public Sub Aufgaben_laden()

        ' variablen für den stream und den reader (zum LESEN)
        Dim myFileStream As New FileStream("Aufgaben.txt", FileMode.Open)
        Dim myReader As New BinaryReader(myFileStream)

        Dim Zeilen As Integer
        Aufgaben.Clear()
        xbutton.Clear()

        ' den inhalt einlesen und in die variablen speichern
        Zeilen = myReader.ReadInt32()
        For i = 0 To Zeilen - 1
            Aufgaben.Add(New Aufgabe(myReader.ReadString(), myReader.ReadString(), myReader.ReadInt32(), myReader.ReadInt32()))
            xbutton.Add(New tbutton(Aufgaben(i).Aufgabe, i))
        Next i

        ' datei wieder schliessen (wichtig!)
        myReader.Close()

    End Sub

    Public Sub Aufgaben_speichern()
        ' variablen für den stream und den writer (zum SCHREIBEN)
        Dim myFileStream As New FileStream("Aufgaben.txt", FileMode.OpenOrCreate)
        Dim myWriter As New BinaryWriter(myFileStream)

        Dim anzahl As Integer = Aufgaben.Count
        myWriter.Write(anzahl)

        For i = 0 To anzahl - 1
            myWriter.Write(Aufgaben(i).Aufgabe)
            myWriter.Write(Aufgaben(i).Arbeitgeber)
            'myWriter.Write(Aufgaben(i).Typ)
            myWriter.Write(Aufgaben(i).Verdienst)
            myWriter.Write(Aufgaben(i).Stundenpreis)
        Next
        ' datei wieder schliessen (wichtig!)
        myWriter.Close()
    End Sub
    Public Sub Taetigkeit_speichern(Name)
        ' variablen für den stream und den writer (zum SCHREIBEN)
        Dim myWriter As New StreamWriter("Taetigkeit.txt", True)
        ' Dim myWriter As New BinaryWriter(myFileStream)

        myWriter.WriteLine(Name)
        myWriter.WriteLine(Now)

        myWriter.Close()

    End Sub

    Private Sub Taetigkeiten_laden()
        Taetigkeiten.Clear()
        ' variablen für den stream und den reader (zum LESEN)
        ' Dim myFileStream As New FileStream("Taetigkeiten.txt", FileMode.Open)
        Dim myReader As New StreamReader("Taetigkeit.txt")
        Dim i = 0
        Do
            ' den inhalt einlesen und in die variablen speichern
            Dim xaufg = myReader.ReadLine
            Dim xzeit = myReader.ReadLine

            If Not xaufg Is Nothing Then
                If Not xzeit Is Nothing Then
                    Taetigkeiten.Add(New Taetigkeit(xaufg, xzeit))
                    i = Taetigkeiten.Count
                    If i > 1 Then
                        i = i - 2
                        Taetigkeiten(i).Endezeit = xzeit
                        Taetigkeiten(i).Dauer_Calc()
                    End If

                Else
                    i = Taetigkeiten.Count
                    If i > i > 1 Then
                        i = i - 1
                        Taetigkeiten(i).Endezeit = Now
                        Taetigkeiten(i).Dauer_Calc()
                    End If
                    Exit Do
                End If
            Else
                i = Taetigkeiten.Count
                If i > 1 Then
                    i = i - 1
                    Taetigkeiten(i).Endezeit = Now
                    Taetigkeiten(i).Dauer_Calc()
                End If
                Exit Do
            End If

            i = i + 1
        Loop
        myReader.Close()

    End Sub

    Private Sub Form1_MouseMove(sender As Object, e As MouseEventArgs) Handles MyBase.MouseMove
        Me.Width = 400
    End Sub

    Private Sub Form1_MouseLeave(sender As Object, e As EventArgs) Handles MyBase.MouseLeave
        If MousePosition.X > 100 Then
            Me.Width = 2
        End If
    End Sub

    Private Sub Form1_Load(sender As Object, e As EventArgs) Handles MyBase.Load
        Aufgaben_laden()
    End Sub


    Private Sub btNeuT_Click(sender As Object, e As EventArgs) Handles btNeuT.Click

        Aufgaben.Add(New Aufgabe(InputBox("Bitte Aufgabenamen eingeben", "Aufagabe"), InputBox("Bitte Auftragsgeber eingeben", "Auftragsgeber"), 0))
        Aufgaben_speichern()
        Aufgaben_laden()

    End Sub

    Private Sub BtExit_Click(sender As Object, e As EventArgs) Handles BtExit.Click
        Taetigkeit_speichern("ENDE")
        Me.Width = 400
        End
    End Sub

    Private Sub BtAusw_Click(sender As Object, e As EventArgs) Handles BtAusw.Click
        Taetigkeiten_laden()
        Auswerten()
        frmAuswertung.Show()
    End Sub

    Private Sub Form1_FormClosing(ByVal sender As Object, ByVal e As System.Windows.Forms.FormClosingEventArgs) Handles Me.FormClosing
        Taetigkeit_speichern("ENDE")
        Me.Width = 400
    End Sub

    Private Sub Auswerten()
        Aufgaben_laden()

        For i = 0 To Taetigkeiten.Count - 1
            If Taetigkeiten(i).Aufgabe <> "ENDE" Then
                For j = 0 To Aufgaben.Count - 1

                    If Aufgaben(j).Aufgabe = Taetigkeiten(i).Aufgabe Then
                        If Aufgaben(j).FruehstesDatum = #12:00:00 AM# Then Aufgaben(j).FruehstesDatum = Taetigkeiten(i).Startzeit
                        Dim Monat = Taetigkeiten(i).Startzeit.Month
                        Aufgaben(j).ArbeitszeitMonat(Monat) = Aufgaben(j).ArbeitszeitMonat(Monat) + Taetigkeiten(i).Dauer
                        Aufgaben(j).ArbeitszeitMonat(0) = Aufgaben(j).ArbeitszeitMonat(0) + Taetigkeiten(i).Dauer

                        Exit For
                    End If
                Next
            End If
        Next

    End Sub

    Private Sub Button3_Click(sender As Object, e As EventArgs) Handles Button3.Click
        Taetigkeit_speichern("ENDE")
        lbinfo.Text = "Pause"
    End Sub

    Private Sub Button2_Click(sender As Object, e As EventArgs) Handles Button2.Click
        Form4.Show()
    End Sub
End Class

Public Class Aufgabe
    Public Aufgabe As String
    'Public Typ As Integer  'Typ1 Festpreis, Typ2 Stundenlohn, Typ3 Tantiemen
    Public Arbeitgeber As String

    Public Verdienst As Integer
    Public Stundenpreis As Integer
    '   Public ArbeitszeitGesamt As Integer
    Public ArbeitszeitMonat(13) As Integer
    Public FruehstesDatum As Date


    Public Sub New(ByVal Aufgabe As String, ByVal Arbeitgeber As String, Optional Verdienst As Integer = 0, Optional ByVal Stundenpreis As Integer = 0)
        Me.Aufgabe = Aufgabe
        Me.Arbeitgeber = Arbeitgeber
        ' Me.Typ = Typ

        Me.Stundenpreis = Stundenpreis
        Me.Verdienst = Verdienst
    End Sub
End Class

Public Class tbutton
    Inherits Button

    Public index As Integer

    Public Sub New(ByVal name As String, ByVal index As Integer)
        Me.Name = index
        Me.index = index
        Me.Text = name
        Me.Size = Form1.Button1.Size
        Me.Location = Form1.Button1.Location
        If index > 0 Then Me.Location = New Point(Me.Location.X, 13 + index * 42)
        Me.BackColor = Color.AliceBlue
        AddHandler Me.Click, AddressOf myButton_click
        Form1.Controls.Add(Me)
    End Sub

    Public Sub mybutton_click()
        Form1.Taetigkeit_speichern(Me.Text)
        Form1.lbinfo.Text = Me.Text
    End Sub
End Class

Public Class Taetigkeit
    Public Aufgabe As String
    Public Startzeit As Date
    Public Endezeit As Date
    Public Dauer As String

    Public Sub New(ByVal Aufgabe As String, ByVal Startzeit As String)
        Me.Aufgabe = Aufgabe
        Me.Startzeit = Startzeit
    End Sub

    Public Sub Dauer_Calc()
        Dim wD As Long = DateDiff(DateInterval.Minute, Me.Startzeit, Me.Endezeit)
        If wD > 600 And Me.Aufgabe <> "ENDE" Then MsgBox(wD & " " & Me.Startzeit)

        Me.Dauer = wD

    End Sub
End Class